matrix world;
matrix view;
matrix proj;
float scale;

float3 sqFaceNorm[6] = {
	float3(  0.0, 0.0, -1.0 ),
	float3(  1.0, 0.0,  0.0 ),
	float3(  0.0, 0.0,  1.0 ),
	float3( -1.0, 0.0,  0.0 ),
	float3(  0.0, 1.0,  0.0 ),
	float3(  0.0, -1.0,  0.0 )
};

float3 sqVtx[8] = {
	float3( -1.0, -1.0, -1.0 ),
	float3(  1.0, -1.0, -1.0 ),
	float3( -1.0,  1.0, -1.0 ),
	float3(  1.0,  1.0, -1.0 ),
	float3( -1.0, -1.0,  1.0 ),
	float3(  1.0, -1.0,  1.0 ),
	float3( -1.0,  1.0,  1.0 ),
	float3(  1.0,  1.0,  1.0 )
};

int sqIdx[36] = {
	0, 2, 1,
	1, 2, 3,
	1, 3, 5,
	5, 3, 7,
	5, 7, 4,
	4, 7, 6,
	4, 6, 0,
	0, 6, 2,
	2, 6, 3,
	3, 6, 7,
	0, 1, 5,
	0, 5, 4
};

struct VS_INPUT {
	float3 pos : POSITION;
	float3 norm : TEXCOORD0;
};

struct GS_INPUT {
	float4 pos : SV_POSITION;
	float3 norm : TEXCOORD0;
};

struct PS_INPUT {
	float4 pos : SV_POSITION;
	float3 norm : TEXCOORD0;
};

// _VF[_
GS_INPUT vsMain( VS_INPUT In ) {
	// [Jʒû܂܃WIgVF[_
	GS_INPUT Out;
	Out.pos = float4( In.pos, 1.0 );
	Out.norm = In.norm;
	return Out;
}

[MaxVertexCount(108)]
void gsMain( triangle GS_INPUT In[3], inout TriangleStream<PS_INPUT> triStream ) {

	// e_Ɉ̂̑傫ƂȂZo
	float L01 = length( In[1].pos.xyz - In[0].pos.xyz );
	float L12 = length( In[2].pos.xyz - In[1].pos.xyz );
	float L02 = length( In[0].pos.xyz - In[2].pos.xyz );
	float sqScale[3] = {
		min( L01, L02 ),
		min( L01, L12 ),
		min( L12, L02 )
	};
	
	// _̈ʒuɗ̂zuWVPϊ
	// @WV
	float4x4 wv = mul( world, view );	// HLSLł*Zq͎gȂI
	float4x4 wvp = mul( wv, proj );
	int faceId = 0;
	for ( int v = 0; v < 3; ++v ) {
		for ( int p = 0; p < 12; ++p ) {
			faceId = p / 2;
			for ( int i = 0; i < 3; ++i ) {
				PS_INPUT Out;
				int idx = sqIdx[ p * 3 + i ];
				float3 localP = sqVtx[ idx ] * sqScale[ v ] * scale + In[ v ].pos.xyz;
				Out.pos  = mul( float4( localP, 1.0 ), wvp );
				Out.norm = mul( float4( sqFaceNorm[ faceId ], 0.0 ), wv ).xyz;
				triStream.Append( Out );
			}
			triStream.RestartStrip();
		}
	}
}

float4 psMain( PS_INPUT In ) : SV_TARGET {
	float p = 1.0;
	return float4( float3( 0.8, 0.8, 0.8 ) * ( -normalize( In.norm ).z ), 1.0 );
}

RasterizerState rs {
	FillMode = SOLID;
	CullMode = BACK;
	FrontCounterClockWise = FALSE;
	DepthBias = 0;
	DepthBiasClamp = 0;
	SlopeScaledDepthBias = 0;
	DepthClipEnable = FALSE;
	ScissorEnable = FALSE;
	MultiSampleEnable = FALSE;
	AntiAliasedLineEnable = FALSE;
};

BlendState bs {
	AlphaToCoverageEnable = FALSE;
	BlendEnable[0] = FALSE;
	SrcBlend = ONE;
	DestBlend = ZERO;
	BlendOp = REV_SUBTRACT;
	SrcBlendAlpha = ONE;
	DestBlendAlpha = ZERO;
	BlendOpAlpha = ADD;
	RenderTargetWriteMask[0] = 0x0F;
};

DepthStencilState dss {
	DepthEnable = TRUE;
	DepthWriteMask = ALL;
	DepthFunc = LESS;
	StencilEnable = FALSE;
	StencilReadMask = 0xff;
	StencilWriteMask = 0xff;
	FrontFaceStencilFail = KEEP;
	FrontFaceStencilDepthFail = KEEP;
	FrontFaceStencilPass = KEEP;
	FrontFaceStencilFunc = ALWAYS;
	BackFaceStencilFail = KEEP;
	BackFaceStencilDepthFail = KEEP;
	BackFaceStencilPass = KEEP;
	BackFaceStencilFunc = ALWAYS;
};

// eNjbN
technique10 tech {
	pass p0 {
		SetVertexShader( CompileShader( vs_4_0, vsMain() ) );
		SetGeometryShader( CompileShader( gs_4_0, gsMain() ) );
		SetPixelShader( CompileShader( ps_4_0, psMain() ) );
		
		SetRasterizerState( rs );
		SetBlendState( bs, float4( 0.0f, 0.0f, 0.0f, 0.0f ), 0xFFFFFFFF );
		SetDepthStencilState( dss, 0 );
	}
}
