#pragma comment(lib, "dxguid.lib")
#pragma comment(lib, "d3d10.lib")
#pragma comment(lib, "d3dx10.lib")

#include <windows.h>
#include <tchar.h>
#include <d3d10.h>
#include <d3dx10.h>
#include "oxcp.h"
#include "oxstlparser.h"
#include "oxnumericcounter.h"


using namespace OX;

int wheelCount_g = 0;
int cameraCurRot_g = 0;


// ʑ̂̃J̋vZ
float calcCameraDist( float &cameraHeight, float r, float fovY, float viewHeight ) {
	float hy = viewHeight;
	float l = r / sinf( fovY / 2.0f );
	float hr = cameraHeight - hy;
	if ( l >= hr )
		return sqrtf( l * l - hr * hr );
	cameraHeight = ( l + hy ) * cosf( (float)D3DXToRadian( 1.0f ) );
	return l * sinf( (float)D3DXToRadian( 1.0f ) );
}

// EBhEvV[W
LRESULT CALLBACK WndProc( HWND hWnd, UINT mes, WPARAM wParam, LPARAM lParam ) {

	static int cameraRotStartVal = 0;

	switch ( mes ) {
	case WM_DESTROY:
		PostQuitMessage( 0 );
		return 0;
	case WM_MOUSEWHEEL:
		wheelCount_g += GET_WHEEL_DELTA_WPARAM( wParam ) / WHEEL_DELTA;
		break;
	case WM_LBUTTONDOWN:
		cameraRotStartVal = LOWORD( lParam );
		break;
	case WM_MOUSEMOVE:
		if ( wParam & MK_LBUTTON ) {
			int cameraRotDif = LOWORD( lParam ) - cameraRotStartVal;
			cameraRotStartVal = LOWORD( lParam );
			cameraCurRot_g += cameraRotDif;
		}
		break;
	}
	return DefWindowProc( hWnd, mes, wParam, lParam );
}

// C
int APIENTRY _tWinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow )
{
	// STL烂ff[^쐬
	// R}hCɃt@C΂D
	std::string parseFileName( "horse.stl" );
	if ( strlen( lpCmdLine ) > 0 ) {
		parseFileName = lpCmdLine;
	}
	STLParser parser;
	if ( parser.parseFromFile( parseFileName.c_str() ) == false ) {
		MessageBoxA( 0, "STLt@C̓ǂݍ݂Ɏs܂B", "ǂݍ݃G[", 0 );
		return -1;
	}
	AABB aabb = parser.calcAABB();

	auto vertices = parser.getVertices();
	auto verticesSize = parser.getVerticesSize();
	auto indices = parser.getIndices();


	// EBhE쐬
	MSG msg; HWND hWnd;
	TCHAR gName[] = _T( "WIgVF[_TvvO" );
	WNDCLASSEX wcex = { sizeof( WNDCLASSEX ), CS_HREDRAW | CS_VREDRAW, WndProc, 0, 0, hInstance, NULL, NULL,
		(HBRUSH)( COLOR_WINDOW + 1 ), NULL, (TCHAR*)gName, NULL };
	if ( !RegisterClassEx( &wcex ) )
		return 0;

	int w = 1000, h = 750;
	RECT clientRect = { 0, 0, w, h };
	::AdjustWindowRect( &clientRect, WS_OVERLAPPEDWINDOW, FALSE );

	if ( !( hWnd = CreateWindow( gName, gName, WS_OVERLAPPEDWINDOW, CW_USEDEFAULT, 0,
		clientRect.right - clientRect.left, clientRect.bottom - clientRect.top,
		NULL, NULL, hInstance, NULL ) ) )
		return 0;

	ShowWindow( hWnd, nCmdShow );


	// Direct3D10̏ //
	cp< ID3D10Device > cpDevice_;
	cp< IDXGISwapChain > cpSwapChain_;
	cp< ID3D10RenderTargetView > cpRenderTargetView_;

	// Xbv`FCƃfoCX̏
	{
		DXGI_SWAP_CHAIN_DESC desc;
		memset( &desc, 0, sizeof( desc ) );
		desc.BufferCount = 1;
		desc.BufferDesc.Width = w;
		desc.BufferDesc.Height = h;
		desc.BufferDesc.Format = DXGI_FORMAT_R8G8B8A8_UNORM;
		desc.BufferDesc.Scaling = DXGI_MODE_SCALING_UNSPECIFIED;
		desc.BufferDesc.RefreshRate.Numerator = 60;
		desc.BufferDesc.RefreshRate.Denominator = 1;
		desc.BufferDesc.ScanlineOrdering = DXGI_MODE_SCANLINE_ORDER_UNSPECIFIED;
		desc.BufferUsage = DXGI_USAGE_RENDER_TARGET_OUTPUT;
		desc.Flags = DXGI_SWAP_CHAIN_FLAG_ALLOW_MODE_SWITCH;
		desc.OutputWindow = hWnd;
		desc.SampleDesc.Count = 1;
		desc.SampleDesc.Quality = 0;
		desc.SwapEffect = DXGI_SWAP_EFFECT_DISCARD;
		desc.Windowed = TRUE;

		if ( FAILED( D3D10CreateDeviceAndSwapChain(
			0,
			D3D10_DRIVER_TYPE_HARDWARE,
			0,
			0,
			D3D10_SDK_VERSION,
			&desc,
			cpSwapChain_.toCreator(),
			cpDevice_.toCreator()
		) ) ) {
			return false;
		}
	}

	// obNobt@m
	ID3D10Texture2D *backBuffer;
	if ( FAILED( cpSwapChain_->GetBuffer( 0, __uuidof( ID3D10Texture2D ), (void**)&backBuffer ) ) ) {
		return false;
	}

	cp< ID3D10RenderTargetView > backBufferRenderTargetView_;
	if ( FAILED( cpDevice_->CreateRenderTargetView( backBuffer, 0, backBufferRenderTargetView_.toCreator() ) ) ) {
		return false;
	}
	cpDevice_->OMSetRenderTargets( 1, backBufferRenderTargetView_.getPtrPtr(), 0 );	// o̓}[Wɐݒ

	// [xXeVobt@쐬
	cp< ID3D10Texture2D > depthStencil;
	D3D10_TEXTURE2D_DESC dstDesc;
	dstDesc.Width = w;
	dstDesc.Height = h;
	dstDesc.MipLevels = 1;
	dstDesc.ArraySize = 1;
	dstDesc.Format = DXGI_FORMAT_D32_FLOAT;
	dstDesc.SampleDesc.Count = 1;
	dstDesc.SampleDesc.Quality = 0;
	dstDesc.Usage = D3D10_USAGE_DEFAULT;
	dstDesc.BindFlags = D3D10_BIND_DEPTH_STENCIL;
	dstDesc.CPUAccessFlags = 0;
	dstDesc.MiscFlags = 0;
	cpDevice_->CreateTexture2D( &dstDesc, 0, depthStencil.toCreator() );

	cp< ID3D10DepthStencilView > dsView;
	D3D10_DEPTH_STENCIL_VIEW_DESC dsvDesc;
	dsvDesc.Format = dstDesc.Format;
	dsvDesc.ViewDimension = D3D10_DSV_DIMENSION_TEXTURE2D;
	dsvDesc.Texture2D.MipSlice = 0;
	cpDevice_->CreateDepthStencilView( depthStencil.getPtr(), &dsvDesc, dsView.toCreator() );

	// r[|[gݒ
	D3D10_VIEWPORT vp;
	vp.TopLeftX = 0;
	vp.TopLeftY = 0;
	vp.Width = w;
	vp.Height = h;
	vp.MinDepth = 0.0f;
	vp.MaxDepth = 1.0f;

	// _obt@
	D3D10_BUFFER_DESC vtxBufDesc;
	vtxBufDesc.Usage = D3D10_USAGE_DEFAULT;
	vtxBufDesc.ByteWidth = verticesSize;
	vtxBufDesc.BindFlags = D3D10_BIND_VERTEX_BUFFER;
	vtxBufDesc.CPUAccessFlags = 0;
	vtxBufDesc.MiscFlags = 0;

	D3D10_SUBRESOURCE_DATA vtxData;
	memset( &vtxData, 0, sizeof( vtxData ) );
	vtxData.pSysMem = &vertices[ 0 ];

	cp< ID3D10Buffer > vtxBuffer;
	cpDevice_->CreateBuffer( &vtxBufDesc, &vtxData, vtxBuffer.toCreator() );

	// ̓CAEg
	D3D10_INPUT_ELEMENT_DESC layout[] = {
		{ "POSITION", 0, DXGI_FORMAT_R32G32B32_FLOAT, 0, 0, D3D10_INPUT_PER_VERTEX_DATA, 0 },
	{ "TEXCOORD", 0, DXGI_FORMAT_R32G32B32_FLOAT, 0, 12, D3D10_INPUT_PER_VERTEX_DATA, 0 }
	};

	// CfbNXobt@
	D3D10_BUFFER_DESC idxBufDesc;
	memset( &idxBufDesc, 0, sizeof( idxBufDesc ) );
	idxBufDesc.Usage = D3D10_USAGE_DEFAULT;
	idxBufDesc.ByteWidth = indices.size() * sizeof( uint32_t );
	idxBufDesc.BindFlags = D3D10_BIND_INDEX_BUFFER;

	D3D10_SUBRESOURCE_DATA idxData;
	memset( &idxData, 0, sizeof( idxData ) );
	idxData.pSysMem = &indices[ 0 ];

	cp< ID3D10Buffer > idxBuffer;
	cpDevice_->CreateBuffer( &idxBufDesc, &idxData, idxBuffer.toCreator() );

	// GtFNg
	cp< ID3D10Effect > effect;
	ID3D10Blob *err = 0;
	auto res = D3DX10CreateEffectFromFile( "geometry_sample.fx", 0, 0, "fx_4_0", D3D10_SHADER_ENABLE_STRICTNESS, 0, cpDevice_.getPtr(), 0, 0, effect.toCreator(), &err, 0 );;
	if ( FAILED( res ) ) {
		const char* errStr = (const char*)err->GetBufferPointer();
		OutputDebugStringA( errStr );
		return -1;
	}

	cp< ID3D10InputLayout > vtxLayout;
	ID3D10EffectTechnique *tech = effect->GetTechniqueByName( "tech" );
	ID3D10EffectPass *pass = tech->GetPassByIndex( 0 );
	D3D10_PASS_DESC passDesc;
	pass->GetDesc( &passDesc );
	cpDevice_->CreateInputLayout( layout, 2, passDesc.pIAInputSignature, passDesc.IAInputSignatureSize, vtxLayout.toCreator() );

	// STLZAbvȂ̂YAbvɕύX
	// IuWFNg̒__ɈړAX-90x]nʂɐݒu
	D3DXMATRIX world, rotXMat, offsetCenterMat, placeXZMat;
	float rotX = (float)D3DXToRadian( -90.0f );
	D3DXMatrixRotationX( &rotXMat, rotX );
	AABB worldAABB = aabb.rot( AABB::Axis_X );
	D3DXMatrixTranslation( &offsetCenterMat, -aabb.center_.x, -aabb.center_.y, -aabb.center_.z );
	world = offsetCenterMat * rotXMat;
	world._42 += worldAABB.halfLen3_.y;

	// Jp[^
	float cameraDist = 0.0f;
	float r = worldAABB.halfLen3_.len();
	float viewPointHeight = worldAABB.halfLen3_.y;
	float cameraHeight = worldAABB.halfLen3_.y * 3.0f;
	float cameraHeightUnit = worldAABB.halfLen3_.y * 0.4f;
	NumericCounter cameraHeightCtr( cameraHeight, 0.01f, 0.1f );
	NumericCounter cameraRotCtr( 0.0f, 0.01f, 0.1f );

	// `p[^
	D3DXMATRIX view, proj;
	float fovY = (float)D3DXToRadian( 30.0f );
	D3DXMatrixPerspectiveFovLH( &proj, fovY, (float)w / h, 0.1f, 1000.0f );

	float clearColor[ 4 ] = { 0.0f, 0.0f, 0.0f, 1.0f };
	float scale = 0.3f;

	do {
		if ( PeekMessage( &msg, NULL, 0, 0, PM_REMOVE ) ) {
			TranslateMessage( &msg );
			DispatchMessage( &msg );
		}
		else {
			// JʒuXV
			cameraHeight += wheelCount_g * cameraHeightUnit;
			if ( wheelCount_g != 0 ) {
				cameraHeightCtr.setAim( cameraHeight );
			}
			wheelCount_g = 0;
			if ( cameraHeight < viewPointHeight )
				cameraHeight = viewPointHeight;
			auto curCameraHight = cameraHeightCtr.update();
			cameraDist = calcCameraDist( curCameraHight, r, fovY, viewPointHeight );

			cameraRotCtr.setAim( -cameraCurRot_g * 0.01f );
			auto cameraRot = cameraRotCtr.update();

			D3DXMatrixLookAtLH( &view, &D3DXVECTOR3( cameraDist * cosf( cameraRot ), curCameraHight, cameraDist * sinf( cameraRot ) ), &D3DXVECTOR3( 0.0f, viewPointHeight, 0.0f ), &D3DXVECTOR3( 0.0f, 1.0f, 0.0f ) );

			// Direct3D̏
			cpDevice_->RSSetViewports( 1, &vp );
			cpDevice_->OMSetRenderTargets( 1, backBufferRenderTargetView_.getPtrPtr(), dsView.getPtr() );
			cpDevice_->ClearRenderTargetView( backBufferRenderTargetView_.getPtr(), clearColor );
			cpDevice_->ClearDepthStencilView( dsView.getPtr(), D3D10_CLEAR_DEPTH, 1.0f, 0 );

			// f`
			auto worldV = effect->GetVariableByName( "world" );
			worldV->AsMatrix()->SetMatrix( (float*)&world );
			auto viewV = effect->GetVariableByName( "view" );
			viewV->AsMatrix()->SetMatrix( (float*)&view );
			auto projV = effect->GetVariableByName( "proj" );
			projV->AsMatrix()->SetMatrix( (float*)&proj );
			auto scaleV = effect->GetVariableByName( "scale" );
			scaleV->AsScalar()->SetFloat( scale );

			const UINT stride = sizeof( STLParser::Vertex );
			const UINT offset = 0;
			cpDevice_->IASetVertexBuffers( 0, 1, vtxBuffer.getPtrPtr(), &stride, &offset );
			cpDevice_->IASetIndexBuffer( idxBuffer.getPtr(), DXGI_FORMAT_R32_UINT, 0 );
			cpDevice_->IASetInputLayout( vtxLayout.getPtr() );
			cpDevice_->IASetPrimitiveTopology( D3D10_PRIMITIVE_TOPOLOGY_TRIANGLELIST );

			tech->GetPassByIndex( 0 )->Apply( 0 );
			cpDevice_->DrawIndexed( indices.size(), 0, 0 );

			cpSwapChain_->Present( 1, 0 );
		}
	} while ( msg.message != WM_QUIT );

	cpDevice_->ClearState();

	return 0;
}