#ifndef __IKD_OX_BASE_OXAABB_H__
#define __IKD_OX_BASE_OXAABB_H__


#include "oxfloat.h"

namespace OX {

	/**
	* @brief EAABB
	*
	* sE{bNX(AABB)\܂Bx[X̌`XYZeӂ̒1ŒS__ɂ܂B
	*/
	class AABB {
	public:
		/**
		* @brief ]
		*/
		enum Axis {
			Axis_X,	//!< X
			Axis_Y,	//!< Y
			Axis_Z	//!< Z
		};

		AABB() : center_( 0.0f, 0.0f, 0.0f ) {
			halfLen_[ 0 ] = 0.5f;
			halfLen_[ 1 ] = 0.5f;
			halfLen_[ 2 ] = 0.5f;
		}

		AABB( const Vec3 &xyzLen ) : center_( 0.0f, 0.0f, 0.0f ) {
			halfLen3_ = xyzLen;
		}

		/**
		* @brief x[X`ӂ̒Őݒ
		*/
		void setXYZLen( const Vec3 &xyzLen ) {
			halfLen3_ = xyzLen.abs() / 2.0f;
		}

		/**
		* @brief S_ړ
		*/
		void setCenter( const Vec3 &center ) {
			center_ = center;
		}

		/**
		* @brief ̈_ōXV
		* @param[in] p ̈XV_B
		*
		* x[Ẍ_p̍WōXV܂B_pAABBɊ܂܂ĂȂꍇA̓_܂܂悤AABB͈̔͂XV܂B
		* _܂܂Ăꍇ͂̂܂܂łB
		*/
		void updateRegion( const Vec3 &p ) {
			Vec3 min3( center_ - halfLen3_ );
			Vec3 max3( center_ + halfLen3_ );
			bool isUpdate = false;
			for ( int i = 0; i < 3; ++i ) {
				if ( p.f[ i ] < center_.f[ i ] - halfLen_[ i ] ) {
					min3.f[ i ] = p.f[ i ];
					isUpdate = true;
				}
				else if ( p.f[ i ] > center_.f[ i ] + halfLen_[ i ] ) {
					max3.f[ i ] = p.f[ i ];
					isUpdate = true;
				}
			}
			if ( isUpdate == true ) {
				halfLen3_ = ( max3 - min3 ) * 0.5f;
				center_ = ( min3 + max3 ) * 0.5f;
			}
		}

		/**
		* @brief p]AABB擾
		* @param[in] axis 
		* @return ]AABB
		*
		* w̎90x]AABBԂ܂B]̒SAABB̒ScenterłB
		*/
		AABB rot( Axis axis ) const {
			AABB retAABB = *this;
			switch ( axis ) {
			case Axis_X: swap( retAABB, 1, 2 ); break;
			case Axis_Y: swap( retAABB, 0, 2 ); break;
			case Axis_Z: swap( retAABB, 0, 1 ); break;
			}
			return retAABB;
		}

	private:
		void swap( AABB &aabb, int a, int b ) const {
			float tmp = aabb.halfLen_[ a ];
			aabb.halfLen_[ a ] = aabb.halfLen_[ b ];
			aabb.halfLen_[ b ] = tmp;
		}

	public:
		union {
			Vec3 halfLen3_;			//!< ӂ̒̔iVec3\j
			float halfLen_[ 3 ];	//!< ӂ̒̔ifloatz\j
		};
		Vec3 center_;		//!< S_W
	};
}

#endif
