#ifndef __IKD_OX_STLPARSER_H__
#define __IKD_OX_STLPARSER_H__


#include "oxfloat.h"
#include <vector>
#include "oxaabb.h"


namespace OX {

	/**
	* @brief STLp[T[
	*
	* STLf[^p[XĒ_i[܂B
	*/
	class STLParser {
	public:
		struct Vertex {
			OX::Vec3 p_;	// W
			OX::Vec3 n_;	// _@
		};

	public:
		STLParser();
		~STLParser();

		/**
		* @brief STLf[^ǂݍ
		* @param[in] stlData STLf[^i[Ă郁ubN 
		* @param[in] size f[^ubÑoCg
		* @param[in] isBinary f[^oCi`ȂtrueAeLXg`Ȃfalse
		* @return i[ɐtrue
		*
		* STLf[^ǂݍݒ_Ɋi[܂B
		*/
		bool parse( const char* stlData, size_t size, bool isBynary = true );

		/**
		* @brief STLt@C璼ڃf[^ǂݍ
		* @param[in] stlData STLf[^i[Ă郁ubN
		* @param[in] size f[^ubÑoCg
		* @param[in] isBinary f[^oCi`ȂtrueAeLXg`Ȃfalse
		* @return i[ɐtrue
		*
		* STLt@C璼ڃf[^ǂݍݒ_Ɋi[܂B
		*/
		bool parseFromFile( const char* filePath, bool isBynary = true );

		/**
		* @brief _z擾
		* @return _z
		*/
		const std::vector< Vertex > &getVertices() const;

		/**
		* @brief _z̃TCY擾
		* @return _z̃TCY
		*/
		size_t getVerticesSize() const;

		/**
		* @brief CfbNXz擾
		*/
		const std::vector< uint32_t > &getIndices() const;

		/**
		* @brief EAABBvZ
		* @return fAABB
		*/
		AABB calcAABB() const;

	private:
		std::vector< Vertex > vertices_;	//!< _z
		std::vector< uint32_t > indices_;	//!< CfbNXz
	};
}

#endif
